p = 0.0005; // mesh size
air_b = 1e-1;  // boundary for air
mag_w = 3.18e-3;  // magnet width
mag_l = 14e-3;  //magnet length
mag_h = 6.35e-3;  //magnet height
mag_offset = mag_h; // offset from y=0 axis

y2 = mag_offset - 2*mag_h;  // Y coord at bottom of magnet 1
y3 = mag_offset - mag_h;  // Y coord at bottom of magnet 2
y4 = mag_offset;
y5 = mag_offset + mag_h;  //Y coord at top of magnet 3
y6 = mag_offset + 2*mag_h;  //Y coord at top of magnet 4

Point(1) = {-air_b,-air_b,0,3*p};
Point(2) = {-mag_w,-air_b,0,3*p};
Point(3) = {0,-air_b,0,3*p};
Point(4) = {air_b,-air_b,0,3*p};

Point(5) = {-air_b, y2,0,3*p};
Point(6) = {-mag_w, y2,0,3*p};
Point(7) = {0, y2,0,3*p};
Point(8) = {air_b, y2,0,3*p};

Point(9) = {-air_b, y3,0,3*p};
Point(10) = {-mag_w, y3,0,3*p};
Point(11) = {0, y3,0,3*p};
Point(12) = {air_b, y3,0,3*p};

Point(13) = {-air_b, y4,0,3*p};
Point(14) = {-mag_w, y4,0,3*p};
Point(15) = {0, y4,0,3*p};
Point(16) = {air_b, y4,0,3*p};

Point(17) = {-air_b, y5,0,3*p};
Point(18) = {-mag_w, y5,0,3*p};
Point(19) = {0, y5,0,3*p};
Point(20) = {air_b, y5,0,3*p};

Point(21) = {-air_b, y6,0,3*p};
Point(22) = {-mag_w, y6,0,3*p};
Point(23) = {0, y6,0,3*p};
Point(24) = {air_b, y6,0,3*p};

Point(25) = {-air_b,air_b,0,3*p};
Point(26) = {-mag_w,air_b,0,3*p};
Point(27) = {0,air_b,0,3*p};
Point(28) = {air_b,air_b,0,3*p};
Line(1) = {1, 2};
Line(2) = {2, 3};
Line(3) = {3, 4};
Line(4) = {5, 6};
Line(5) = {6, 7};
Line(6) = {7, 8};
Line(7) = {9, 10};
Line(8) = {10, 11};
Line(9) = {11, 12};
Line(10) = {13, 14};
Line(11) = {14, 15};
Line(12) = {15, 16};
Line(13) = {17, 18};
Line(14) = {18, 19};
Line(15) = {19, 20};
Line(16) = {21, 22};
Line(17) = {22, 23};
Line(18) = {23, 24};
Line(19) = {25, 26};
Line(20) = {26, 27};
Line(21) = {27, 28};
Line(22) = {1, 5};
Line(23) = {5, 9};
Line(24) = {9, 13};
Line(25) = {13, 17};
Line(26) = {17, 21};
Line(27) = {21, 25};
Line(28) = {2, 6};
Line(29) = {6, 10};
Line(30) = {10, 14};
Line(31) = {14, 18};
Line(32) = {18, 22};
Line(33) = {22, 26};
Line(34) = {3, 7};
Line(35) = {7, 11};
Line(36) = {11, 15};
Line(37) = {15, 19};
Line(38) = {19, 23};
Line(39) = {23, 27};
Line(40) = {4, 8};
Line(41) = {8, 12};
Line(42) = {12, 16};
Line(43) = {16, 20};
Line(44) = {20, 24};
Line(45) = {24, 28};
Line Loop(46) = {22, 4, -28, -1};
Plane Surface(47) = {46};
Line Loop(48) = {5, -34, -2, 28};
Plane Surface(49) = {48};
Line Loop(50) = {34, 6, -40, -3};
Plane Surface(51) = {50};
Line Loop(52) = {7, -29, -4, 23};
Plane Surface(53) = {52};
Line Loop(54) = {8, -35, -5, 29};
Plane Surface(55) = {54};
Line Loop(56) = {35, 9, -41, -6};
Plane Surface(57) = {56};
Line Loop(58) = {10, -30, -7, 24};
Plane Surface(59) = {58};
Line Loop(60) = {11, -36, -8, 30};
Plane Surface(61) = {60};
Line Loop(62) = {12, -42, -9, 36};
Plane Surface(63) = {62};
Line Loop(64) = {13, -31, -10, 25};
Plane Surface(65) = {64};
Line Loop(66) = {14, -37, -11, 31};
Plane Surface(67) = {66};
Line Loop(68) = {37, 15, -43, -12};
Plane Surface(69) = {68};
Line Loop(70) = {16, -32, -13, 26};
Plane Surface(71) = {70};
Line Loop(72) = {17, -38, -14, 32};
Plane Surface(73) = {72};
Line Loop(74) = {18, -44, -15, 38};
Plane Surface(75) = {74};
Line Loop(76) = {18, 45, -21, -39};
Plane Surface(77) = {76};
Line Loop(78) = {17, 39, -20, -33};
Plane Surface(79) = {78};
Line Loop(80) = {19, -33, -16, 27};
Plane Surface(81) = {80};

Transfinite Line {2, 5, 8, 11, 14, 17, 20} = 20;
Transfinite Line {1, 4, 7, 10, 13, 16, 19} = 120 Using Progression 0.98;
Transfinite Line {3, 6, 9, 12, 15, 18, 21} = 130 Using Progression 1.02;
Transfinite Line {22, 28, 34, 40} = 60 Using Progression 0.945;
Transfinite Line {27, 33, 39, 45} = 60 Using Progression 1.055;
Transfinite Line {23, 24, 25, 26, 29, 30, 31, 32, 35, 36, 37, 38, 41, 42, 43, 44} = 30;

Transfinite Surface{47} = {1, 2, 6, 5};
Transfinite Surface{49} = {2, 3, 7, 6};
Transfinite Surface{51} = {3, 4, 8, 7};
Transfinite Surface{53} = {5, 6, 10, 9};
Transfinite Surface{55} = {6, 7, 11, 10};
Transfinite Surface{57} = {7, 8, 12, 11};
Transfinite Surface{59} = {9, 10, 14, 13};
Transfinite Surface{61} = {10, 11, 15, 14};
Transfinite Surface{63} = {11, 12, 16, 15};
Transfinite Surface{65} = {13, 14, 18, 17};
Transfinite Surface{67} = {14, 15, 19, 18};
Transfinite Surface{69} = {15, 16, 20, 19};
Transfinite Surface{71} = {17, 18, 22, 21};
Transfinite Surface{73} = {18, 19, 23, 22};
Transfinite Surface{75} = {19, 20, 24, 23};
Transfinite Surface{81} = {21, 22, 26, 25};
Transfinite Surface{79} = {22, 23, 27, 26};
Transfinite Surface{77} = {23, 24, 28, 27};
Recombine Surface {47:81};

Physical Surface(97) = {55}; //magnet
Physical Surface(98) = {61}; //magnet1
Physical Surface(99) = {67}; //magnet2
Physical Surface(100) = {73}; //magnet3
Physical Surface(101) = {47, 49, 51, 53, 57, 59, 63, 65, 69, 71, 75, 77, 79, 81}; //air
Physical Line(1000) = {1, 2, 3, 19, 20, 21, 22, 23, 24, 25, 26, 27, 40, 41, 42, 43, 44, 45}; //system boundary